<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_TransportElement ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_TransportElement extends AbstractStructArrayBase
{
    /**
     * The TransportElement
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_TransportElement[]
     */
    public $TransportElement;
    /**
     * Constructor method for ArrayOfJP_TransportElement
     * @uses ArrayOfJP_TransportElement::setTransportElement()
     * @param \StructType\JP_TransportElement[] $transportElement
     */
    public function __construct(array $transportElement = array())
    {
        $this
            ->setTransportElement($transportElement);
    }
    /**
     * Get TransportElement value
     * @return \StructType\JP_TransportElement[]|null
     */
    public function getTransportElement()
    {
        return $this->TransportElement;
    }
    /**
     * This method is responsible for validating the values passed to the setTransportElement method
     * This method is willingly generated in order to preserve the one-line inline validation within the setTransportElement method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateTransportElementForArrayConstraintsFromSetTransportElement(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfJP_TransportElementTransportElementItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_TransportElementTransportElementItem instanceof \StructType\JP_TransportElement) {
                $invalidValues[] = is_object($arrayOfJP_TransportElementTransportElementItem) ? get_class($arrayOfJP_TransportElementTransportElementItem) : sprintf('%s(%s)', gettype($arrayOfJP_TransportElementTransportElementItem), var_export($arrayOfJP_TransportElementTransportElementItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The TransportElement property can only contain items of type \StructType\JP_TransportElement, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set TransportElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportElement[] $transportElement
     * @return \ArrayType\ArrayOfJP_TransportElement
     */
    public function setTransportElement(array $transportElement = array())
    {
        // validation for constraint: array
        if ('' !== ($transportElementArrayErrorMessage = self::validateTransportElementForArrayConstraintsFromSetTransportElement($transportElement))) {
            throw new \InvalidArgumentException($transportElementArrayErrorMessage, __LINE__);
        }
        $this->TransportElement = $transportElement;
        return $this;
    }
    /**
     * Add item to TransportElement value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_TransportElement $item
     * @return \ArrayType\ArrayOfJP_TransportElement
     */
    public function addToTransportElement(\StructType\JP_TransportElement $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_TransportElement) {
            throw new \InvalidArgumentException(sprintf('The TransportElement property can only contain items of type \StructType\JP_TransportElement, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->TransportElement[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_TransportElement|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_TransportElement|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_TransportElement|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_TransportElement|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_TransportElement|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string TransportElement
     */
    public function getAttributeName()
    {
        return 'TransportElement';
    }
}
